'''
Created on 17 jun 2009

@author: Niels
'''
from PyQt4 import QtCore, QtGui

class Ui_HistoryLineWidget(object):
    def setupUi(self, HistoryLineWidget):
        HistoryLineWidget.setObjectName("HistoryLineWidget")
        HistoryLineWidget.resize(495, 60)
        
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(HistoryLineWidget.sizePolicy().hasHeightForWidth())
        HistoryLineWidget.setSizePolicy(sizePolicy)
        HistoryLineWidget.setMinimumSize(QtCore.QSize(0, 40))
        HistoryLineWidget.setMaximumSize(QtCore.QSize(16777215, 40))
        self.horizontalLayout_2 = QtGui.QHBoxLayout(HistoryLineWidget)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.horizontalLayout = QtGui.QHBoxLayout()
        self.horizontalLayout.setSpacing(0)
        self.horizontalLayout.setMargin(0)
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.ExpandButton = QtGui.QPushButton(HistoryLineWidget)
        self.ExpandButton.setObjectName("ExpandButton")
        self.horizontalLayout.addWidget(self.ExpandButton)
        
        self.ActorPlaceHolder = QtGui.QLabel(HistoryLineWidget)
        self.ActorPlaceHolder.setMargin(6)
        self.ActorPlaceHolder.setObjectName("ActorPlaceHolder")
        self.horizontalLayout.addWidget(self.ActorPlaceHolder)
        self.SentencePlaceHolder = QtGui.QLabel(HistoryLineWidget)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.SentencePlaceHolder.sizePolicy().hasHeightForWidth())
        self.SentencePlaceHolder.setSizePolicy(sizePolicy)
        self.SentencePlaceHolder.setMargin(6)
        self.SentencePlaceHolder.setObjectName("SentencePlaceHolder")
        self.horizontalLayout.addWidget(self.SentencePlaceHolder)
        
        self.horizontalLayout_2.addLayout(self.horizontalLayout)
        self.horizontalLayout_2.setSpacing(0)
        self.horizontalLayout_2.setMargin(0)
        self.retranslateUi(HistoryLineWidget)
        QtCore.QMetaObject.connectSlotsByName(HistoryLineWidget)

    def retranslateUi(self, HistoryLineWidget):
        HistoryLineWidget.setWindowTitle(QtGui.QApplication.translate("HistoryLineWidget", "Form", None, QtGui.QApplication.UnicodeUTF8))
        self.ActorPlaceHolder.setText(QtGui.QApplication.translate("HistoryLineWidget", "{"+str(self.childrenCount)+"}   "+str(self.actor), None, QtGui.QApplication.UnicodeUTF8))
        self.SentencePlaceHolder.setText(QtGui.QApplication.translate("HistoryLineWidget", self.sentence, None, QtGui.QApplication.UnicodeUTF8))
        self.ExpandButton.setText(QtGui.QApplication.translate("HistoryLineWidget", "Jump To", None, QtGui.QApplication.UnicodeUTF8))

class HistoryLineWidget(QtGui.QFrame,Ui_HistoryLineWidget):
    
    def __init__(self,parent,actor,actorColor,sentence,buttonFunction,childrenCount,active):
        QtGui.QWidget.__init__(self,parent)
        
        self.actor = actor
        self.sentence = sentence
        self.childrenCount = childrenCount
        
        r ,g ,b, a = actorColor.getRgb()
        self.setStyleSheet("QWidget { background-color:  rgb("+str(r)+","+str(g)+" ,"+str(b)+" ) }")
        
        self.setupUi(self)
        
        if active:
            self.setFrameShape(QtGui.QFrame.Box)
            
        
        
        self.connect(self.ExpandButton,QtCore.SIGNAL('clicked()'),buttonFunction)
        