class historyHolder():
    
    def __init__(self):
        self.dialog = None
        self.clearAll()
        
    def addToHistory(self,historyPoint):
        
        
        self.history = self.history[0:self.historyPointer]
        self.historyPointer += 1
        self.history.append(historyPoint)
        if not self.dialog == None:
            self.dialog.fillInDialog(self.history,self.historyPointer)
    
    def jumpToHistoryPoint(self,index):
        self.historyPointer = index    
    
    def getNextHistoryPoint(self):
        self.historyPointer += 1
        if len(self.history) > self.historyPointer:
            if not self.dialog == None:
                self.dialog.fillInDialog(self.history,self.historyPointer)
            return self.history[self.historyPointer]
        else:
            self.historyPointer = len(self.history)
            return None
    
    def showPreviousHistoryPoint(self):
        
        if self.historyPointer-1 >= 0:
            return self.history[self.historyPointer-1]
        else:
            return None
    
    def showNextHistoryPoint(self):
        if len(self.history) > self.historyPointer+1:
            return self.history[self.historyPointer+1]
        else:
            
            return None
        
    def getPreviousHistoryPoint(self):
        self.historyPointer -= 1
        if self.historyPointer >= 0:
            
            if not self.dialog == None:
                self.dialog.fillInDialog(self.history,self.historyPointer)
            return self.history[self.historyPointer]
        else:
            self.historyPointer = 0
            return None
    
    def getCurrentHistoryPoint(self):
        if self.historyPointer >= 0 and len(self.history) > self.historyPointer:
            if not self.dialog == None:
                self.dialog.fillInDialog(self.history,self.historyPointer)
            return self.history[self.historyPointer]
        else:
            return None
        
    def clearAll(self):
        self.history = []
        self.historyPointer = 0
        if not self.dialog == None:
            self.dialog.fillInDialog(self.history)
        
    def count(self):
        return len(self.history)
    
    def setDialog(self,dialog):
        self.dialog = dialog
        if not self.dialog == None:
            self.dialog.fillInDialog(self.history,self.historyPointer)
    
    def __str__(self):
        string = str(self.historyPointer)
        for point in self.history:
            string += "\n "+str(point.getActiveSentenceId())+" | "+str(point.getViewSentenceIds())
        
        return string
    