# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'ActionManagement.ui'
#
# Created: Mon Jun 15 09:43:19 2009
#      by: PyQt4 UI code generator 4.4.4
#
# WARNING! All changes made in this file will be lost!

from PyQt4 import QtCore, QtGui
from Action import Action
from insertDialogWindow import insertDialogWindow


class Ui_ActionManager(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("Dialog")
        Dialog.resize(691, 663)
        Dialog.setModal(True)
        self.horizontalLayout_2 = QtGui.QHBoxLayout(Dialog)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.horizontalLayout = QtGui.QHBoxLayout()
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.verticalLayout_2 = QtGui.QVBoxLayout()
        self.verticalLayout_2.setObjectName("verticalLayout_2")
        self.horizontalLayout_3 = QtGui.QHBoxLayout()
        self.horizontalLayout_3.setObjectName("horizontalLayout_3")
        self.label = QtGui.QLabel(Dialog)
        self.label.setObjectName("label")
        self.horizontalLayout_3.addWidget(self.label)
        self.lineEdit = QtGui.QLineEdit(Dialog)
        self.lineEdit.setObjectName("lineEdit")
        Dialog.connect(self.lineEdit,QtCore.SIGNAL('textChanged(const QString&)'),self.searchOn)
        self.horizontalLayout_3.addWidget(self.lineEdit)
        self.verticalLayout_2.addLayout(self.horizontalLayout_3)
        self.ActionListTable = QtGui.QTableWidget(Dialog)
        self.ActionListTable.setSelectionMode(QtGui.QAbstractItemView.ExtendedSelection)
        self.ActionListTable.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.ActionListTable.setObjectName("ActionListTable")
        self.verticalLayout_2.addWidget(self.ActionListTable)
        #Dialog.connect(self.ActionListTable,QtCore.SIGNAL('itemClicked (QTableWidgetItem *)'),Dialog.selectChanged)
        
        self.horizontalLayout.addLayout(self.verticalLayout_2)
        self.verticalLayout = QtGui.QVBoxLayout()
        self.verticalLayout.setObjectName("verticalLayout")
        self.RenameButton = QtGui.QPushButton(Dialog)
        self.RenameButton.setObjectName("RenameButton")
        Dialog.connect(self.RenameButton,QtCore.SIGNAL('clicked()'),Dialog.renameSelected)
        self.verticalLayout.addWidget(self.RenameButton)
        self.MergButton = QtGui.QPushButton(Dialog)
        self.MergButton.setObjectName("MergButton")
        Dialog.connect(self.MergButton,QtCore.SIGNAL('clicked()'),Dialog.mergeSelected)
        self.verticalLayout.addWidget(self.MergButton)
        spacerItem = QtGui.QSpacerItem(20, 40, QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Expanding)
        self.verticalLayout.addItem(spacerItem)
        self.label_2 = QtGui.QLabel(Dialog)
        self.label_2.setObjectName("label_2")
        self.verticalLayout.addWidget(self.label_2)
        self.RemovePreButton = QtGui.QPushButton(Dialog)
        self.RemovePreButton.setObjectName("RemovePreButton")
        Dialog.connect(self.RemovePreButton,QtCore.SIGNAL('clicked()'),Dialog.removePreActions)
        self.verticalLayout.addWidget(self.RemovePreButton)
        self.RemovePostButton = QtGui.QPushButton(Dialog)
        self.RemovePostButton.setObjectName("RemovePostButton")
        Dialog.connect(self.RemovePostButton,QtCore.SIGNAL('clicked()'),Dialog.removePostActions)
        self.verticalLayout.addWidget(self.RemovePostButton)
        self.RemoveAllButton = QtGui.QPushButton(Dialog)
        self.RemoveAllButton.setObjectName("RemoveAllButton")
        Dialog.connect(self.RemoveAllButton,QtCore.SIGNAL('clicked()'),Dialog.removeAllActions)
        self.verticalLayout.addWidget(self.RemoveAllButton)
        spacerItem1 = QtGui.QSpacerItem(20, 40, QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Expanding)
        self.verticalLayout.addItem(spacerItem1)
        self.CloseButton = QtGui.QPushButton(Dialog)
        self.CloseButton.setObjectName("CloseButton")
        self.verticalLayout.addWidget(self.CloseButton)
        Dialog.connect(self.CloseButton,QtCore.SIGNAL('clicked()'),QtCore.SLOT('close()'))
        self.horizontalLayout.addLayout(self.verticalLayout)
        self.horizontalLayout_2.addLayout(self.horizontalLayout)

        self.retranslateUi(Dialog)
        QtCore.QMetaObject.connectSlotsByName(Dialog)

    def retranslateUi(self, Dialog):
        Dialog.setWindowTitle(QtGui.QApplication.translate("Dialog", "Action Manager", None, QtGui.QApplication.UnicodeUTF8))
        self.label.setText(QtGui.QApplication.translate("Dialog", "Search", None, QtGui.QApplication.UnicodeUTF8))
        self.RenameButton.setText(QtGui.QApplication.translate("Dialog", "Rename", None, QtGui.QApplication.UnicodeUTF8))
        self.MergButton.setText(QtGui.QApplication.translate("Dialog", "Merge", None, QtGui.QApplication.UnicodeUTF8))
        self.label_2.setText(QtGui.QApplication.translate("Dialog", "Remove:", None, QtGui.QApplication.UnicodeUTF8))
        self.RemovePreButton.setText(QtGui.QApplication.translate("Dialog", "Pre", None, QtGui.QApplication.UnicodeUTF8))
        self.RemovePostButton.setText(QtGui.QApplication.translate("Dialog", "Post", None, QtGui.QApplication.UnicodeUTF8))
        self.RemoveAllButton.setText(QtGui.QApplication.translate("Dialog", "All", None, QtGui.QApplication.UnicodeUTF8))
        self.CloseButton.setText(QtGui.QApplication.translate("Dialog", "Close", None, QtGui.QApplication.UnicodeUTF8))

class ActionManagementDialog(QtGui.QDialog,Ui_ActionManager):
    
    def __init__(self,parent,engine):
        QtGui.QDialog.__init__(self,parent)
        self.db = engine.getDatabase()
        self.setupUi(self)
        self.fillTable()
        
    def fillTable(self):
        self.actions = self.db.getAllActionsTuple()
        #print self.ActionListTable
        self.ActionListTable.setColumnCount(5)
        self.ActionListTable.setRowCount(len(self.actions))
        headers = ['id','Action','Pre','Post','Total']
        self.ActionListTable.setColumnWidth(0,20)
        self.ActionListTable.setColumnWidth(2,40)
        self.ActionListTable.setColumnWidth(3,40)
        self.ActionListTable.setColumnWidth(4,40)
        self.ActionListTable.setHorizontalHeaderLabels(headers)
        counter = 0
        biggest = 30
        for action in self.actions:
            itemId = QtGui.QTableWidgetItem(str(action[0]))
            itemString = QtGui.QTableWidgetItem(action[1])
            preCount = self.db.getPreActionCount(action[0])
            postCount = self.db.getPostActionCount(action[0])
            itemPreCounter = QtGui.QTableWidgetItem(str(preCount))
            itemPostCounter = QtGui.QTableWidgetItem(str(postCount))
            itemAllCounter = QtGui.QTableWidgetItem(str(preCount+postCount))
            if len(action[1]) > biggest:
                biggest = len(action[1])
            self.ActionListTable.setItem(counter,0,itemId)
            self.ActionListTable.setItem(counter,1,itemString)
            self.ActionListTable.setItem(counter,2,itemPreCounter)
            self.ActionListTable.setItem(counter,3,itemPostCounter)
            self.ActionListTable.setItem(counter,4,itemAllCounter)
            counter += 1
        
        biggest = biggest * 5
        #print biggest    
        self.ActionListTable.setColumnWidth(1,biggest)
        
        
    def searchOn(self,text):
        self.ActionListTable.clearSelection()
        text = str(text)
        text = text.strip()
        text = text.lower()
        counter = 0
        for action in self.actions:
            action = action[1].lower()
            if action.startswith(text):
                self.ActionListTable.selectRow(counter)
                self.ActionListTable.scrollToItem(self.ActionListTable.item(counter,0))
                break
            counter += 1
    
    def renameSelected(self):
        selected = self.ActionListTable.selectedItems()
        rows = set()
        for select in selected:
            rows.add(select.row())
        
        for row in rows:
            action = self.actions[row]
            
            itemList = self.db.getAllActions()
            
            itemList.remove(action[1])
            
            insertDialog = insertDialogWindow(self,"Rename Action","New name:","rename",itemList,False,None)
            
            insertDialog.exec_()
            
            result = insertDialog.getResult()
            if len(result ) > 0:
                self.db.updateAction(action[0],result)
        
        self.fillTable()
    
    def mergeSelected(self):
        selected = self.ActionListTable.selectedItems()
        rows = set()
        for select in selected:
            rows.add(select.row())
        
        itemList = []
        first = None
        idList = dict()
        
        for row in rows:
            itemList.append(self.actions[row][1])
            idList[self.actions[row][1]] = self.actions[row][0]
            if first == None:
                first = self.actions[row][1] 
        insertDialog = insertDialogWindow(self,"Merge Action To","search:","Merge",itemList,True,first)
            
        insertDialog.exec_()
        
        result = insertDialog.getResult()
        
        itemList.remove(result)
        mergeToId = idList[result]
        mergeToPreAction = Action(result,Action.PREACTION,id=mergeToId)
        mergeToPostAction = Action(result,Action.POSTACTION,id=mergeToId)
        for item in itemList:
            preList = self.db.getAllSentencesWithAction(idList[item],Action.PREACTION)
            postList = self.db.getAllSentencesWithAction(idList[item],Action.POSTACTION)
            
            for sentence in preList:
                self.db.removeActionFrom(sentence.getId(),idList[item],Action.PREACTION)
                actionList = sentence.getPreActionList()
                order = -1
                for action in actionList:
                    if action.getAction() == item:
                        order = action.getOrder()
                
                mergeToPreAction.setOrder(order)
                self.db.updateActionList(mergeToPreAction,sentence.getId())
                
            for sentence in postList:
                self.db.removeActionFrom(sentence.getId(),idList[item],Action.POSTACTION)
                actionList = sentence.getPostActionList()
                order = -1
                for action in actionList:
                    if action.getAction() == item:
                        order = action.getOrder()
                
                mergeToPostAction.setOrder(order)
                self.db.updateActionList(mergeToPostAction,sentence.getId())
            self.db.removeAction(idList[item])
        self.fillTable()
    
    def removePreActions(self):
        selected = self.ActionListTable.selectedItems()
        rows = set()
        for select in selected:
            rows.add(select.row())
        
                
        for row in rows:
            action = self.actions[row]
            reply = QtGui.QMessageBox.question(self, 'Remove Pre Action',"Are you sure you want to remove this pre action?: \n ["+str(action[0])+"] "+str(action[1]), QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
    
            if reply == QtGui.QMessageBox.Yes:
                
                preList = self.db.getAllSentencesWithAction(action[0],Action.PREACTION)
            
                for sentence in preList:
                    self.db.removeActionFrom(sentence.getId(),action[0],Action.PREACTION)
    
            else:
                pass            
        self.fillTable()    
    def removePostActions(self):
        selected = self.ActionListTable.selectedItems()
        rows = set()
        for select in selected:
            rows.add(select.row())
        
                
        for row in rows:
            action = self.actions[row]
            reply = QtGui.QMessageBox.question(self, 'Remove Post Action',"Are you sure you want to remove this post action?: \n ["+str(action[0])+"] "+str(action[1]), QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
    
            if reply == QtGui.QMessageBox.Yes:
                
                preList = self.db.getAllSentencesWithAction(action[0],Action.POSTACTION)
            
                for sentence in preList:
                    self.db.removeActionFrom(sentence.getId(),action[0],Action.POSTACTION)
    
            else:
                pass            
        self.fillTable()    
    
    def removeAllActions(self):
        selected = self.ActionListTable.selectedItems()
        rows = set()
        for select in selected:
            rows.add(select.row())
        
                
        for row in rows:
            action = self.actions[row]
            reply = QtGui.QMessageBox.question(self, 'Remove Action',"Are you sure you want to remove this action?: \n ["+str(action[0])+"] "+str(action[1]), QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
        
            if reply == QtGui.QMessageBox.Yes:
                
                self.db.removeAction(action[0])
    
            else:
                pass
        self.fillTable()
    
    def quit(self):
        self.close()
        
    
                