# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'PropertyManagement.ui'
#
# Created: Mon Jun 15 11:10:46 2009
#      by: PyQt4 UI code generator 4.4.4
#
# WARNING! All changes made in this file will be lost!

from PyQt4 import QtCore, QtGui

class Ui_PropertyManager(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("Dialog")
        Dialog.resize(691, 663)
        self.horizontalLayout_2 = QtGui.QHBoxLayout(Dialog)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.horizontalLayout = QtGui.QHBoxLayout()
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.verticalLayout_2 = QtGui.QVBoxLayout()
        self.verticalLayout_2.setObjectName("verticalLayout_2")
        self.horizontalLayout_3 = QtGui.QHBoxLayout()
        self.horizontalLayout_3.setObjectName("horizontalLayout_3")
        self.label = QtGui.QLabel(Dialog)
        self.label.setObjectName("label")
        self.horizontalLayout_3.addWidget(self.label)
        self.lineEdit = QtGui.QLineEdit(Dialog)
        Dialog.connect(self.lineEdit,QtCore.SIGNAL('textChanged(const QString&)'),self.searchOn)
        self.lineEdit.setObjectName("lineEdit")
        self.horizontalLayout_3.addWidget(self.lineEdit)
        self.verticalLayout_2.addLayout(self.horizontalLayout_3)
        self.PropertyTable = QtGui.QTableWidget(Dialog)
        self.PropertyTable.setEditTriggers(QtGui.QAbstractItemView.NoEditTriggers)
        self.PropertyTable.setSelectionMode(QtGui.QAbstractItemView.SingleSelection)
        self.PropertyTable.setSelectionBehavior(QtGui.QAbstractItemView.SelectRows)
        self.PropertyTable.setObjectName("PropertyTable")
        self.verticalLayout_2.addWidget(self.PropertyTable)
        self.horizontalLayout.addLayout(self.verticalLayout_2)
        self.verticalLayout = QtGui.QVBoxLayout()
        self.verticalLayout.setObjectName("verticalLayout")
        self.VisibleButton = QtGui.QPushButton(Dialog)
        self.VisibleButton.setObjectName("VisibleButton")
        Dialog.connect(self.VisibleButton,QtCore.SIGNAL('clicked()'),Dialog.setPropertyVisible)
        self.verticalLayout.addWidget(self.VisibleButton)
        self.UnvisibleButton = QtGui.QPushButton(Dialog)
        self.UnvisibleButton.setObjectName("UnvisibleButton")
        Dialog.connect(self.UnvisibleButton,QtCore.SIGNAL('clicked()'),Dialog.setPropertyUnvisible)
        self.verticalLayout.addWidget(self.UnvisibleButton)
        spacerItem = QtGui.QSpacerItem(20, 40, QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Expanding)
        self.verticalLayout.addItem(spacerItem)
        self.removeButton = QtGui.QPushButton(Dialog)
        self.removeButton.setObjectName("removeButton")
        self.verticalLayout.addWidget(self.removeButton)
        Dialog.connect(self.removeButton,QtCore.SIGNAL('clicked()'),Dialog.removeProperty)
        spacerItem1 = QtGui.QSpacerItem(20, 40, QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Expanding)
        self.verticalLayout.addItem(spacerItem1)
        self.CloseButton = QtGui.QPushButton(Dialog)
        self.CloseButton.setObjectName("CloseButton")
        Dialog.connect(self.CloseButton,QtCore.SIGNAL('clicked()'),QtCore.SLOT('close()'))
        
        self.verticalLayout.addWidget(self.CloseButton)
        self.horizontalLayout.addLayout(self.verticalLayout)
        self.horizontalLayout_2.addLayout(self.horizontalLayout)

        self.retranslateUi(Dialog)
        QtCore.QMetaObject.connectSlotsByName(Dialog)

    def retranslateUi(self, Dialog):
        Dialog.setWindowTitle(QtGui.QApplication.translate("Dialog", "Property Manager", None, QtGui.QApplication.UnicodeUTF8))
        self.label.setText(QtGui.QApplication.translate("Dialog", "Search", None, QtGui.QApplication.UnicodeUTF8))
        self.VisibleButton.setText(QtGui.QApplication.translate("Dialog", "Visible", None, QtGui.QApplication.UnicodeUTF8))
        self.UnvisibleButton.setText(QtGui.QApplication.translate("Dialog", "Invisible", None, QtGui.QApplication.UnicodeUTF8))
        self.removeButton.setText(QtGui.QApplication.translate("Dialog", "Remove", None, QtGui.QApplication.UnicodeUTF8))
        self.CloseButton.setText(QtGui.QApplication.translate("Dialog", "Close", None, QtGui.QApplication.UnicodeUTF8))

class PropertyManagementDialog(QtGui.QDialog,Ui_PropertyManager):
    
    def __init__(self,parent,engine):
        QtGui.QDialog.__init__(self,parent)
        self.parent = parent
        self.db = engine.getDatabase()
        self.setupUi(self)
        self.fillTable()
        
        
    def fillTable(self):
        #self.PropertyTable.clear()
        self.properties = self.db.getAllPropertiesTuple(False)
       
        self.PropertyTable.setColumnCount(5)
        self.PropertyTable.setRowCount(len(self.properties))
        headers = ['id','Property','Visible','count','values']
        self.PropertyTable.setColumnWidth(0,20)
        self.PropertyTable.setColumnWidth(2,60)
        self.PropertyTable.setHorizontalHeaderLabels(headers)
        counter = 0
        biggest = 30
        for property in self.properties:
            itemId = QtGui.QTableWidgetItem(str(property[0]))
            itemString = QtGui.QTableWidgetItem(property[1])
            itemVisible = QtGui.QTableWidgetItem("False")
            if property[2] == 1:
                itemVisible = QtGui.QTableWidgetItem("True")
            itemCount = QtGui.QTableWidgetItem(str(self.db.getPropertyCount(property[0])))
            values = list(set(self.db.getAllPropertyValues(property[1])))
            valueString = "" 
            for value in values:
                valueString += value +", "
            valueString = valueString[:len(valueString)-2]
            itemValues = QtGui.QTableWidgetItem(valueString)
            if len(property) > biggest:
                biggest = len(property)
            self.PropertyTable.setItem(counter,0,itemId)
            self.PropertyTable.setItem(counter,1,itemString)
            self.PropertyTable.setItem(counter,2,itemVisible)
            self.PropertyTable.setItem(counter,3,itemCount)
            self.PropertyTable.setItem(counter,4,itemValues)
            counter += 1
        
        biggest = biggest * 5
        #print biggest    
        self.PropertyTable.setColumnWidth(1,biggest)
        
    def searchOn(self,text):
        self.PropertyTable.clearSelection()
        text = str(text)
        text = text.strip()
        text = text.lower()
        counter = 0
        for property in self.properties:
            property = property[1].lower()
            if property.startswith(text):
                self.PropertyTable.selectRow(counter)
                self.PropertyTable.scrollToItem(self.PropertyTable.item(counter,0))
                break
            counter += 1
            
    def setPropertyVisible(self):
        selected = self.PropertyTable.selectedItems()
        for select in selected:
            property = self.properties[select.row()]
            self.db.showProperty(property[0],self.db.ENABLED)
        
        self.fillTable()
    
    def setPropertyUnvisible(self):
        selected = self.PropertyTable.selectedItems()
        for select in selected:
            property = self.properties[select.row()]
            self.db.showProperty(property[0],self.db.DISABLED)
        self.fillTable()
        
    def removeProperty(self):
        selected = self.PropertyTable.selectedItems()
        rows = set()
        for select in selected:
            rows.add(select.row())
        
        for row in rows:
            property = self.properties[row]
            reply = QtGui.QMessageBox.question(self, 'Remove Property',"Are you sure you want to remove this property: \n ["+str(property[0])+"] "+str(property[1]), QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
    
            if reply == QtGui.QMessageBox.Yes:
                
                self.db.removeProperty(property[0])
            else:
                pass
            
        
        self.fillTable()
    
    def quit(self):
        self.close()
            