from Link import Link

class exLink(Link):
    
    def __init__(self,link,reply_to_actor,reply_actor,engine):
        Link.__init__(self,link.getReplyToId(),link.getReplyId(),link.getOrder())
        self.addReplyPeek(link.getReplyPeek())
        self.addReplyToPeek(link.getReplyToPeek())
        
        self.reply_to_actor = reply_to_actor
        
        self.reply_actor = reply_actor
        
        
    def getReplyActor(self):
        return self.reply_actor
    
    def setReplyActor(self,actor):
        self.reply_actor = actor
        
    def getReplyToActor(self):
        return self.reply_to_actor
    
    def setReplyToActor(self,actor):
        self.reply_to_actor = actor
    
    def getReplyActorColor(self):
        return self.engine.getActorList().getActorColor(self.reply_actor)
           
    def getReplyToActorColor(self):
        return self.engine.getActorList().getActorColor(self.reply_to_actor)
     
    def getSentence(self):
        return self.getReplyPeek()
    
    def getActor(self):
        return self.getReplyActor() 
    
    def getId(self):
        return self.getReplyId()   